<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="工器具名称" prop="equipName" label-width="120">
        <el-input
          v-model="queryParams.equipName"
          placeholder="请输入工器具名称"
          v-no-whitespace
          maxlength="100"
          show-word-limit
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="审批状态" prop="status">
        <el-select v-model="queryParams.status">
          <el-option v-for="item in statusOptions" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-button
        v-hasPermi="['system:equip:add']"
        class="filter-item"
        size="mini"
        type="primary"
        icon="el-icon-edit"
        @click="handleAdd"
      >新增
      </el-button>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="equipList" @selection-change="handleSelectionChange">
      <el-table-column
        type="index"
        width="55"
        label="序号"
        align="center"
        :index="indexContinuous(queryParams.pageNum, queryParams.pageSize)"
      />
      <el-table-column label="工器具名称" align="center" prop="equipName" />
      <el-table-column label="型号" align="center" prop="model" />
      <el-table-column label="单位" align="center" prop="unit" />
      <el-table-column label="数量" align="center" prop="num" />
      <el-table-column label="设备类型" align="center" prop="equipType" />
      <el-table-column label="检测时间" align="center" prop="detectionTime" />
      <el-table-column label="是否强制检测检验" align="center" prop="isForceDetection" />
      <el-table-column label="下次检测时间" align="center" prop="nextDetectionTime" />
      <el-table-column label="工器具文件" width="100" align="center">
        <template slot-scope="scope">
          <el-button size="mini" @click="handleShow(scope.row)">查看</el-button>
        </template>
      </el-table-column>
      <el-table-column label="审批状态" align="center" prop="intoStatus">
        <template slot-scope="scope">
          <!-- 检查是否存在身份证号 -->
          <span v-if="scope.row.intoStatus">{{ updateStatus(scope.row.intoStatus)
            }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleSubmit(scope.row)"
            v-hasPermi="['system:equip:edit']"
            v-if="scope.row.intoStatus == '0'"
          >提交审核
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleRevocation(scope.row)"
            v-hasPermi="['system:equip:edit']"
            v-if="scope.row.intoStatus == '1'"
          >撤回
          </el-button>
          <el-button
            size="mini"
            type="text"
            v-if="scope.row.intoStatus == '2' || scope.row.intoStatus == '3'"
            @click="handleView(scope.row)"
            v-hasPermi="['system:equip:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            v-if="scope.row.intoStatus == '0' || scope.row.intoStatus == '4' || scope.row.intoStatus == '5'"
            @click="handleEdit(scope.row)"
            v-hasPermi="['system:equip:edit']"
          >编辑
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleAuditRecord(scope.row)"
            v-hasPermi="['system:audit:query']"
          >审核记录
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-dialog title="工器具信息" :visible.sync="message" width="80%" top="5vh" append-to-body>
      <bns-equip-details-tabs :items="items" :isDisabled="true" />
      <bns-file-list-tabs :items="fileList" />
    </el-dialog>
    <el-dialog title="工器具文件" :visible.sync="document" width="80%" top="5vh" append-to-body>
      <div style="width: 100%;height:720px">
        <bns-file-list-tabs :items="fileList" />
      </div>
    </el-dialog>


  </div>
</template>

<script>
import { listEquip, selectDetails } from '@/api/pro/cons/equip'
import { dictTableOption } from '@/api/tool/select'
import BnsEquipDetailsTabs from '@/components/pro-tabs/bns-equip-details-tabs.vue'
import BnsFileListTabs from '@/components/pro-tabs/bns-file-list-tabs.vue'
import { submitApproval } from '@/api/pro/admissionRequest'
import { getParams, indexContinuous } from '@/utils/bonus'
import { retractApproval } from '@/api/terminalEquipment/deviceInformation'
import { encryptCBC } from '@/utils/aescbc'

export default {
  name: 'Post',
  components: { BnsFileListTabs, BnsEquipDetailsTabs },
  data() {
    return {
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 工程表格数据
      equipList: [],
      items: {},
      fileList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      document: false,
      message: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        equipName: undefined,
        status: undefined,
        type: '入场'
      },
      statusOptions: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      auditStatusDict: {
        '1': '待审批',
        '2': '审批中',
        '3': '已通过',
        '4': '已驳回',
        '5': '已撤销'
      }
    }
  },
  created() {
    this.getList()
    this.getStatus()
  },
  methods: {
    indexContinuous,
    getParams,
    updateStatus(status) {
      return this.auditStatusDict[status]
    },
    /** 查询工程列表 */
    getList() {
      this.loading = true
      this.queryParams.proId = this.$store.state.user.thisIds.proId
      this.queryParams.consUuid = this.$store.state.user.thisIds.consUuid
      listEquip(this.queryParams).then(response => {
        this.equipList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    getStatus() {
      const params = {
        dictType: 'sys_approval_state',
        dictValue: ''
      }
      dictTableOption(params).then(response => {
        this.statusOptions = response.data
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        equipName: undefined,
        postSort: 0
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.proId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 文件查看按钮操作 */
    handleShow(row) {
      this.loading = true
      this.document = true
      selectDetails({ uuid: row.uuid }).then(response => {
        this.fileList = response.fileList
        this.loading = false
      })
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push("/pro/apply/consEquipApply/" + encryptCBC(JSON.stringify({
        uuid: '',
        isExamine: false,
        btnShow: false,
        showType: 1,
        isDisabled: false,
        type: 'add'
      })));
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push("/pro/apply/consEquipApply/" + encryptCBC(JSON.stringify({
        uuid: row.uuid,
        taskId: row.taskId,
        isExamine: false,
        btnShow: false,
        showType: 1,
        isDisabled: true,
        type: 'view'
      })));
    },
    /** 编辑按钮操作 */
    handleEdit(row) {
      this.$router.push("/pro/apply/consEquipApply/" + encryptCBC(JSON.stringify({
        uuid: row.uuid,
        taskId: row.taskId,
        isExamine: false,
        btnShow: false,
        showType: 1,
        isDisabled: false,
        type: 'edit'
      })));
    },
    /** 撤回按钮操作 */
    handleRevocation(row) {
      const params = {
        uuid: row.uuid,
        taskId: row.taskId,
        procInstId: row.procInsId,
        taskType: '8'
      }
      let text = '是否撤回当前工器具的数据项？'
      this.$modal.confirm(text).then(function() {
        return retractApproval(params)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('撤回成功')
      }).catch(() => {
      })
    },
    /** 审核记录按钮操作 */
    handleAuditRecord(row) {
      this.$router.push("/flow/auditRecord/" + encryptCBC(JSON.stringify({
        taskId: row.taskId,
        checkType:'2'
      })));
    },
    handleSubmit(row) {
      console.log(this.getParams())
      const param = {
        ...this.getParams(),
        taskType: '8',
        taskId: row.taskId,
        uuid: row.uuid
      }
      console.log('param=' + JSON.stringify(param))
      submitApproval(param).then(response => {
        console.log('response=' + JSON.stringify(response))
        if (response.code === 200) {
          if (response.msg === '此审核类型未配置相对应的审核流，请联系管理员配置后再次提交'){
            this.$modal.msgError(response.msg)
          }else{
            this.$modal.msgSuccess('提交成功')
          }
          this.getList()
        } else {
          this.$modal.msgError('提交失败')
        }
      })
    }
  }
}
</script>
